diff --git a/MAINTAINERS b/MAINTAINERS
index eefe4edb1b3d..aa08fdb02ecb 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -9527,7 +9527,7 @@ INTEL SCU DRIVERS
 M:	Mika Westerberg <mika.westerberg@linux.intel.com>
 S:	Maintained
 F:	arch/x86/include/asm/intel_scu_ipc.h
-F:	drivers/platform/x86/intel_scu_*
+F:	drivers/platform/x86/intel/scu/
 
 INTEL SKYLAKE INT3472 ACPI DEVICE DRIVER
 M:	Daniel Scally <djrscally@gmail.com>
diff --git a/drivers/platform/x86/Kconfig b/drivers/platform/x86/Kconfig
index aed7570388ef..1b85a1f6fc5f 100644
--- a/drivers/platform/x86/Kconfig
+++ b/drivers/platform/x86/Kconfig
@@ -1159,53 +1159,6 @@ config INTEL_UNCORE_FREQ_CONTROL
 	  To compile this driver as a module, choose M here: the module
 	  will be called intel-uncore-frequency.
 
-config INTEL_SCU_IPC
-	bool
-
-config INTEL_SCU
-	bool
-	select INTEL_SCU_IPC
-
-config INTEL_SCU_PCI
-	bool "Intel SCU PCI driver"
-	depends on PCI
-	select INTEL_SCU
-	help
-	  This driver is used to bridge the communications between kernel
-	  and SCU on some embedded Intel x86 platforms. It also creates
-	  devices that are connected to the SoC through the SCU.
-	  Platforms supported:
-	    Medfield
-	    Clovertrail
-	    Merrifield
-	    Broxton
-	    Apollo Lake
-
-config INTEL_SCU_PLATFORM
-	tristate "Intel SCU platform driver"
-	depends on ACPI
-	select INTEL_SCU
-	help
-	  This driver is used to bridge the communications between kernel
-	  and SCU (sometimes called PMC as well). The driver currently
-	  supports Intel Elkhart Lake and compatible platforms.
-
-config INTEL_SCU_WDT
-	bool
-	default INTEL_SCU_PCI
-	depends on INTEL_MID_WATCHDOG
-	help
-	  This is a specific platform code to instantiate watchdog device
-	  on ACPI-based Intel MID platforms.
-
-config INTEL_SCU_IPC_UTIL
-	tristate "Intel SCU IPC utility driver"
-	depends on INTEL_SCU
-	help
-	  The IPC Util driver provides an interface with the SCU enabling
-	  low level access for debug work and updating the firmware. Say
-	  N unless you will be doing this on an Intel MID platform.
-
 config INTEL_TELEMETRY
 	tristate "Intel SoC Telemetry Driver"
 	depends on X86_64
diff --git a/drivers/platform/x86/Makefile b/drivers/platform/x86/Makefile
index 1668f7360833..026c97ba68f6 100644
--- a/drivers/platform/x86/Makefile
+++ b/drivers/platform/x86/Makefile
@@ -127,11 +127,6 @@ obj-$(CONFIG_INTEL_TURBO_MAX_3)			+= intel_turbo_max_3.o
 obj-$(CONFIG_INTEL_UNCORE_FREQ_CONTROL)		+= intel-uncore-frequency.o
 
 # Intel PMIC / PMC / P-Unit devices
-obj-$(CONFIG_INTEL_SCU_IPC)		+= intel_scu_ipc.o
-obj-$(CONFIG_INTEL_SCU_PCI)		+= intel_scu_pcidrv.o
-obj-$(CONFIG_INTEL_SCU_PLATFORM)	+= intel_scu_pltdrv.o
-obj-$(CONFIG_INTEL_SCU_WDT)		+= intel_scu_wdt.o
-obj-$(CONFIG_INTEL_SCU_IPC_UTIL)	+= intel_scu_ipcutil.o
 obj-$(CONFIG_INTEL_TELEMETRY)		+= intel_telemetry_core.o \
 					   intel_telemetry_pltdrv.o \
 					   intel_telemetry_debugfs.o
diff --git a/drivers/platform/x86/intel/Kconfig b/drivers/platform/x86/intel/Kconfig
index 7de11636904d..72f4a5b79342 100644
--- a/drivers/platform/x86/intel/Kconfig
+++ b/drivers/platform/x86/intel/Kconfig
@@ -21,6 +21,7 @@ source "drivers/platform/x86/intel/int33fe/Kconfig"
 source "drivers/platform/x86/intel/int3472/Kconfig"
 source "drivers/platform/x86/intel/pmc/Kconfig"
 source "drivers/platform/x86/intel/pmt/Kconfig"
+source "drivers/platform/x86/intel/scu/Kconfig"
 
 config INTEL_BXTWC_PMIC_TMU
 	tristate "Intel Broxton Whiskey Cove TMU Driver"
diff --git a/drivers/platform/x86/intel/Makefile b/drivers/platform/x86/intel/Makefile
index a1555a1e421d..15e5124d70ec 100644
--- a/drivers/platform/x86/intel/Makefile
+++ b/drivers/platform/x86/intel/Makefile
@@ -9,6 +9,7 @@ obj-$(CONFIG_INTEL_CHT_INT33FE)		+= int33fe/
 obj-$(CONFIG_INTEL_SKL_INT3472)		+= int3472/
 obj-$(CONFIG_INTEL_PMC_CORE)		+= pmc/
 obj-$(CONFIG_INTEL_PMT_CLASS)		+= pmt/
+obj-$(CONFIG_INTEL_SCU)			+= scu/
 
 # Intel PMIC / PMC / P-Unit drivers
 intel_bxtwc_tmu-y			:= bxtwc_tmu.o
diff --git a/drivers/platform/x86/intel/scu/Kconfig b/drivers/platform/x86/intel/scu/Kconfig
new file mode 100644
index 000000000000..5ce2554e2b90
--- /dev/null
+++ b/drivers/platform/x86/intel/scu/Kconfig
@@ -0,0 +1,51 @@
+# SPDX-License-Identifier: GPL-2.0
+#
+# Intel x86 Platform-Specific Drivers
+#
+
+config INTEL_SCU_IPC
+	bool
+
+config INTEL_SCU_IPC_UTIL
+	tristate "Intel SCU IPC utility driver"
+	depends on INTEL_SCU
+	help
+	  The IPC utility driver provides an interface with the SCU enabling
+	  low level access for debug work and updating the firmware.
+	  Say N unless you will be doing this on an Intel MID platform.
+
+config INTEL_SCU
+	bool
+	select INTEL_SCU_IPC
+
+config INTEL_SCU_PCI
+	bool "Intel SCU PCI driver"
+	depends on PCI
+	select INTEL_SCU
+	help
+	  This driver is used to bridge the communications between kernel
+	  and SCU on some embedded Intel x86 platforms. It also creates
+	  devices that are connected to the SoC through the SCU.
+	  Platforms supported:
+	    Medfield
+	    Clovertrail
+	    Merrifield
+	    Broxton
+	    Apollo Lake
+
+config INTEL_SCU_PLATFORM
+	tristate "Intel SCU platform driver"
+	depends on ACPI
+	select INTEL_SCU
+	help
+	  This driver is used to bridge the communications between kernel
+	  and SCU (sometimes called PMC as well). The driver currently
+	  supports Intel Elkhart Lake and compatible platforms.
+
+config INTEL_SCU_WDT
+	bool
+	default INTEL_SCU_PCI
+	depends on INTEL_MID_WATCHDOG
+	help
+	  This is a specific platform code to instantiate watchdog device
+	  on ACPI-based Intel MID platforms.
diff --git a/drivers/platform/x86/intel/scu/Makefile b/drivers/platform/x86/intel/scu/Makefile
new file mode 100644
index 000000000000..601a720f97dc
--- /dev/null
+++ b/drivers/platform/x86/intel/scu/Makefile
@@ -0,0 +1,15 @@
+# SPDX-License-Identifier: GPL-2.0
+#
+# Intel x86 Platform-Specific Drivers
+#
+
+intel_scu_ipc-y				:= ipc.o
+obj-$(CONFIG_INTEL_SCU_IPC)		+= intel_scu_ipc.o
+intel_scu_ipcutil-y			:= ipcutil.o
+obj-$(CONFIG_INTEL_SCU_IPC_UTIL)	+= intel_scu_ipcutil.o
+intel_scu_pci-y				:= pcidrv.o
+obj-$(CONFIG_INTEL_SCU_PCI)		+= intel_scu_pcidrv.o
+intel_scu_pltdrv-y			:= pltdrv.o
+obj-$(CONFIG_INTEL_SCU_PLATFORM)	+= intel_scu_pltdrv.o
+intel_scu_wdt-y				:= wdt.o
+obj-$(CONFIG_INTEL_SCU_WDT)		+= intel_scu_wdt.o
diff --git a/drivers/platform/x86/intel_scu_ipc.c b/drivers/platform/x86/intel/scu/ipc.c
similarity index 100%
rename from drivers/platform/x86/intel_scu_ipc.c
rename to drivers/platform/x86/intel/scu/ipc.c
diff --git a/drivers/platform/x86/intel_scu_ipcutil.c b/drivers/platform/x86/intel/scu/ipcutil.c
similarity index 100%
rename from drivers/platform/x86/intel_scu_ipcutil.c
rename to drivers/platform/x86/intel/scu/ipcutil.c
diff --git a/drivers/platform/x86/intel_scu_pcidrv.c b/drivers/platform/x86/intel/scu/pcidrv.c
similarity index 100%
rename from drivers/platform/x86/intel_scu_pcidrv.c
rename to drivers/platform/x86/intel/scu/pcidrv.c
diff --git a/drivers/platform/x86/intel_scu_pltdrv.c b/drivers/platform/x86/intel/scu/pltdrv.c
similarity index 100%
rename from drivers/platform/x86/intel_scu_pltdrv.c
rename to drivers/platform/x86/intel/scu/pltdrv.c
diff --git a/drivers/platform/x86/intel_scu_wdt.c b/drivers/platform/x86/intel/scu/wdt.c
similarity index 100%
rename from drivers/platform/x86/intel_scu_wdt.c
rename to drivers/platform/x86/intel/scu/wdt.c